import { select, csv,scaleLinear,
scaleBand,max,axisBottom,axisLeft} from 'd3';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const render=data=>{

//pleasantries
const margin = { top: 60, right: 40, bottom: 88, left: 100 };
const innerWidth = width - margin.left - margin.right;
const innerHeight = height - margin.top - margin.bottom;
  
const xValue=d=>d.name;
const yValue=d=>d.rank;
  


//now for the scales
const xscale=scaleBand()
.domain(data.map(function(d){return d.name}))
.range([0, innerWidth])
.padding(0.2)

const yscale=scaleLinear()
.domain([0, max(data, d=>d.rank)])
.range([innerHeight,0])

const g= svg.append('g')
.attr('transform',`translate(${margin.left},${margin.top})`)

const xAxis= g.append('g').call(axisBottom(xscale))
.attr('transform',`translate(0,${innerHeight})`)

const yAxis= g.append('g').call(axisLeft(yscale))

//now to draw the data

const rectGrp = svg
  .append("g")
  .attr("transform", `translate(${margin.left},${margin.top})`);

rectGrp
  .selectAll("rect")
  .data(data)
  .enter()
  .append("rect")
  .attr("width", xscale.bandwidth())
  .attr("height", (d, i) => {
    return innerHeight - yscale(d.rank);
  })
  .attr("x", d => {
    return xscale(d.name);
  })
  .attr("y", function(d) {
    return yscale(d.rank);
  })
  .attr('fill','orange')

const titleGraph="Suicide Squad Cast";

const title=svg.append('g')
.attr('class','title')
.append('text')
.attr('x',(innerWidth/2)-25)
.attr('y',30)
.text(titleGraph)

};  

d3.json('suicide-squad.json')
.then(function(data){
render(data)  
console.log(data)
})




